package org.springblade.modules.martial.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.martial.pojo.entity.MartialResult;
import org.springblade.modules.martial.service.IMartialResultService;
import org.springframework.web.bind.annotation.*;

/**
 * 成绩表 控制器
 *
 * @author BladeX
 */
@RestController
@AllArgsConstructor
@RequestMapping("/martial/result")
@Tag(name = "成绩表管理", description = "成绩表接口")
public class MartialResultController extends BladeController {

	private final IMartialResultService resultService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@Operation(summary = "详情", description = "传入ID")
	public R<MartialResult> detail(@RequestParam Long id) {
		MartialResult detail = resultService.getById(id);
		return R.data(detail);
	}

	/**
	 * 分页列表
	 */
	@GetMapping("/list")
	@Operation(summary = "分页列表", description = "分页查询")
	public R<IPage<MartialResult>> list(MartialResult result, Query query) {
		IPage<MartialResult> pages = resultService.page(Condition.getPage(query), Condition.getQueryWrapper(result));
		return R.data(pages);
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@Operation(summary = "新增或修改", description = "传入实体")
	public R submit(@RequestBody MartialResult result) {
		return R.status(resultService.saveOrUpdate(result));
	}

	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@Operation(summary = "删除", description = "传入ID")
	public R remove(@RequestParam String ids) {
		return R.status(resultService.removeByIds(Func.toLongList(ids)));
	}

}
